/**
  *  \file planetscentral/talk/talkconnection.h
  *  \brief Talk: Connection Handling
  */
#ifndef C2SERVER_PLANETSCENTRAL_TALK_TALKCONNECTION_H
#define C2SERVER_PLANETSCENTRAL_TALK_TALKCONNECTION_H

#include "cpluslib/string.h"
#include "planetscentral/dbclient/connection.h"
#include "planetscentral/talk/render.h"

class IntArgBlock;

/** Talk Connection. Handles per-connection state. */
class TalkConnection : public Connection {
 public:
    TalkConnection();

    void handleRequest();
    void handleCommand(const string_t& cmd, IntArgBlock& args);

    bool isAdmin() const;
    void checkAdmin();
    void checkUser();
    const string_t& getUser() const;

    bool hasPrivilege(string_t privString);
    void checkPrivilege(string_t privString);

    RenderState& getRenderState();

 private:
    string_t user;
    RenderState renderState;
};

#endif
